const DBDEFINITION = '--db-definition--';

const dbDefinition = {
  _id: DBDEFINITION,
  type: DBDEFINITION,
  version: '0.000001',
};

export const initDb = async (db: any) => {
  try {
    await db.get(DBDEFINITION);
    // TODO: support migrations
  } catch (error: any) {
    if (error.status !== 404) {
      console.log(
        `Unexpected error fetching db definition: ${JSON.stringify(error)}`
      );
      return;
    }
  }

  await db.createIndex({
    index: {
      name: 'type',
      fields: ['type'],
    },
  });

  await db.createIndex({
    index: {
      name: 'trkpt-time',
      fields: ['trkpt.time'],
      partial_filter_selector: {
        type: 'trkpt',
      },
    },
  });

  await db.createIndex({
    index: {
      name: 'type-trkpt-gpx-time3',
      fields: ['type', 'gpx', 'trkpt.time'],
    },
  });

  const indexes = await db.getIndexes();
  console.log(`indexes: ${JSON.stringify(indexes)}`);

  const explain = await db.explain({
    selector: {
      type: 'trkpt',
      gpx: 'xxxx',
    },
    //   sort: ['trkpt.time'],
    // use_index: 'type-trkpt-gpx-time',
  });
  console.log(`explain: ${JSON.stringify(explain)}`);
};
